/*SpUpd!_2019.03.10_0000712*/
/*needVer=2019.03.01_0000711*/

CREATE OR ALTER procedure NEW_CONSILIUM (
    IN_ID_ILL integer,
    IN_NOM_MTL smallint,
    IN_PR_CONS smallint,
    IN_DT_CONS date)
as
begin
  insert into CONSILIUM (ID_ILL, NOM_MTL, PR_CONS, DT_CONS)
  values (:IN_ID_ILL, :IN_NOM_MTL, :IN_PR_CONS, :IN_DT_CONS);
end;
@
CREATE OR ALTER procedure SP_PROVERKI_ONCO (
    ID_ILL integer,
    NOM_MTL smallint,
    OUT_STAC date,
    STAC_DIAG varchar(7),
    ACC1 varchar(7),
    ACC2 varchar(7),
    ACC3 varchar(7),
    MTL_ONCO_STATUS smallint,
    VOZRAST integer,
    OPLAT smallint)
returns (
    OUT_ERR_STAGE smallint,
    OUT_ERR_TUMOR smallint,
    OUT_ERR_NODUS smallint,
    OUT_ERR_METAS smallint,
    OUT_ERR_DIST_METAS smallint,
    OUT_ERR_DOSE smallint,
    OUT_ERR_FRACTIONS smallint,
    OUT_ERR_DECLINE smallint,
    OUT_ERR_DATE_DECLINE smallint,
    OUT_ERR_DIAGNOSTIC_TYPE smallint,
    OUT_ERR_G_SIGN smallint,
    OUT_ERR_G_TEST smallint,
    OUT_ERR_MARKER smallint,
    OUT_ERR_M_RES smallint,
    OUT_ERR_DIRECT_DATE smallint,
    OUT_ERR_DIRECT_TYPE smallint,
    OUT_ERR_METHOD smallint,
    OUT_ERR_USLUG_TO smallint,
    OUT_ERR_BODY_PARAMS integer,
    OUT_ERR_ONCO_USLUG smallint,
    OUT_ERR_ID_CAUSE smallint,
    OUT_ERR_ID_ONCO smallint,
    OUT_ERR_DIAG_DATE smallint,
    OUT_ERR_CONSILIUM smallint,
    OUT_ERR_PR_CONS smallint,
    OUT_ERR_DT_CONS smallint,
    OUT_ERR_U_TYPE smallint,
    OUT_ERR_ID_T_LINE smallint,
    OUT_ERR_ID_T_CYCLE smallint,
    OUT_ERR_R_TYPE smallint,
    OUT_ERR_ONCO_MEDICALS smallint,
    OUT_ERR_CODE_DRUG smallint,
    OUT_ERR_CODE_SCHEM smallint,
    OUT_ERR_DATE_INJ smallint)
as
declare variable P_ID_ONCO integer;
declare variable P_ID_CAUSE smallint;
declare variable P_ID_STAGE smallint;
declare variable P_ID_TUMOR smallint;
declare variable P_ID_NODUS smallint;
declare variable P_ID_METAS smallint;
declare variable P_DIST_METAS smallint;
declare variable P_DOSE numeric(3,2);
declare variable P_ID_DEC smallint;
declare variable P_DATE_DEC date;
declare variable P_DIAG_TYPE smallint;
declare variable P_ID_G_S smallint;
declare variable P_ID_G_T smallint;
declare variable P_ID_MARK smallint;
declare variable P_ID_M_R smallint;
declare variable P_G_S_CHECK smallint;
declare variable P_G_T_CHECK smallint;
declare variable P_MARK_CHECK smallint;
declare variable P_M_RES_CHECK smallint;
declare variable P_DIR_TYPE smallint;
declare variable P_METHOD smallint;
declare variable P_USLUG_TO varchar(20);
declare variable P_DATE_DIR date;
declare variable P_REC_RSLT smallint;
declare variable P_DIAG_DATE date;
declare variable P_FRACTIONS smallint;
declare variable P_WEIGHT numeric(3,1);
declare variable P_HEIGHT smallint;
declare variable P_BSA numeric(3,1);
declare variable P_ID_ILL integer;
declare variable P_NOM_MTL smallint;
declare variable P_PR_CONS smallint;
declare variable P_DT_CONS date;
declare variable P_ID_ONC_USL integer;
declare variable P_ID_U_TYPE smallint;
declare variable P_ID_SURGERY smallint;
declare variable P_ID_T_LINE smallint;
declare variable P_ID_T_CYCLE smallint;
declare variable P_ID_R_TYPE smallint;
declare variable P_CODE_DRUG varchar(6);
declare variable P_CODE_SCHEM varchar(10);
declare variable P_DATE_ONJ date;
begin
OUT_ERR_STAGE = 0;
OUT_ERR_TUMOR = 0;
OUT_ERR_NODUS = 0;
OUT_ERR_METAS = 0;
OUT_ERR_DIST_METAS = 0;
OUT_ERR_DOSE = 0;
OUT_ERR_DECLINE = 0;
OUT_ERR_DATE_DECLINE = 0;
OUT_ERR_DIAGNOSTIC_TYPE = 0;
OUT_ERR_G_SIGN = 0;
OUT_ERR_G_TEST = 0;
OUT_ERR_MARKER = 0;
OUT_ERR_M_RES = 0;
OUT_ERR_DIRECT_DATE = 0;
OUT_ERR_DIRECT_TYPE = 0;
OUT_ERR_METHOD = 0;
OUT_ERR_USLUG_TO = 0;
OUT_ERR_FRACTIONS = 0;
OUT_ERR_BODY_PARAMS = 0;
OUT_ERR_ID_CAUSE = 0;
OUT_ERR_ID_ONCO = 0;
OUT_ERR_DIAG_DATE = 0;
OUT_ERR_PR_CONS = 0;
OUT_ERR_DT_CONS = 0;
OUT_ERR_U_TYPE = 0;
OUT_ERR_ID_T_LINE = 0;
OUT_ERR_ID_T_CYCLE = 0;
OUT_ERR_R_TYPE = 0;
OUT_ERR_CODE_DRUG = 0;
OUT_ERR_CODE_SCHEM = 0;
OUT_ERR_DATE_INJ = 0;
if (MTL_ONCO_STATUS = 1) then --   
begin
OUT_ERR_ONCO_USLUG = 1;
OUT_ERR_CONSILIUM = 1;
OUT_ERR_ONCO_MEDICALS = 1;
select ONC.ID_ONCO, ONC.ID_ILL, ONC.NOM_MTL, ONC.ID_CAUSE, ONC.ID_STAGE, ONC.ID_TUMOR, ONC.ID_NODUS, ONC.ID_METAS, ONC.DIST_METAS, ONC.DOSE, ONC.FRACTIONS, ONC.WEIGHT, ONC.HEIGHT, ONC.BSA
from ONCOLOGY ONC
where ONC.ID_ILL = :ID_ILL and
ONC.NOM_MTL = :NOM_MTL
into :P_ID_ONCO, :P_ID_ILL, :P_NOM_MTL, :P_ID_CAUSE, :P_ID_STAGE, :P_ID_TUMOR, :P_ID_NODUS, :P_ID_METAS, :P_DIST_METAS, :P_DOSE, :P_FRACTIONS, :P_WEIGHT, :P_HEIGHT, :P_BSA;
-------------------------------------------
if (:P_ID_ONCO is null) then
OUT_ERR_ID_ONCO = 1; --      - 
else
begin
if (:P_ID_CAUSE is null) then
OUT_ERR_ID_CAUSE = 1;
-------------------------------------------
for select ODG.DIAG_TYPE, ODG.ID_G_S, ODG.ID_G_T, ODG.ID_MARK, ODG.ID_M_R, ODG.REC_RSLT, ODG.DIAG_DATE
from ONCO_DIAGNOSTIC ODG
where ODG.ID_ONCO = :P_ID_ONCO
into :P_DIAG_TYPE, :P_ID_G_S, :P_ID_G_T, :P_ID_MARK, :P_ID_M_R, :P_REC_RSLT, :P_DIAG_DATE
do
begin
if ((:P_DIAG_DATE is null) and (coalesce(:P_DIAG_TYPE, 0) not in (1,2))) then
OUT_ERR_DIAGNOSTIC_TYPE = 1;
if (:P_DIAG_DATE is null) then
OUT_ERR_DIAG_DATE = 1;
if (:P_DIAG_TYPE = 1) then
begin
OUT_ERR_G_SIGN = 2;
OUT_ERR_G_TEST = 2;
for
select gs.id_g_s, gt.id_g_t
from SPR_ONCO_GIST_SIGNS GS
join SPR_ONCO_SIGN_TO_DIAG SD on SD.ID_G_S = GS.ID_G_S
join SPR_ONCO_GIST_TESTS GT on GT.ID_G_S = GS.ID_G_S
where (cast(:OUT_STAC as date) between GS.DATEBEG and coalesce(GS.DATEEND, '30.12.9999')) and
(cast(:OUT_STAC as date) between SD.DATEBEG and coalesce(SD.DATEEND, '30.12.9999')) and
(cast(:OUT_STAC as date) between GT.DATEBEG and coalesce(GT.DATEEND, '30.12.9999')) and
((:STAC_DIAG like SD.CODE_DIAG || '%') or (:ACC1 like SD.CODE_DIAG || '%') or (:ACC2 like SD.CODE_DIAG || '%') or (:ACC3 like SD.CODE_DIAG || '%'))
into :P_G_S_CHECK, P_G_T_CHECK
do
begin
if (:P_ID_G_S = :P_G_S_CHECK) then
OUT_ERR_G_SIGN = 0;
if ((:P_ID_G_T = :P_G_T_CHECK)) then
OUT_ERR_G_TEST = 0;
end
if (:P_ID_G_S is null) then
OUT_ERR_G_SIGN = 1;
if (:P_ID_G_T is null) then
begin
if (coalesce(:P_REC_RSLT, 0) = 1) then
OUT_ERR_G_TEST = 1;
else
OUT_ERR_G_TEST=0;
end
end
if (:P_DIAG_TYPE = 2) then
begin
OUT_ERR_MARKER = 2;
OUT_ERR_M_RES = 2;
for
select MK.ID_MARK, MR.ID_M_R
from SPR_ONCO_MARKERS MK
join SPR_ONCO_MARK_TO_DIAG MD on MD.ID_MARK = MK.ID_MARK
join SPR_ONCO_MARKER_RESULTS MR on MR.ID_MARK = MK.ID_MARK
where (cast(:OUT_STAC as date) between MK.DATEBEG and coalesce(MK.DATEEND, '30.12.9999')) and
(cast(:OUT_STAC as date) between MD.DATEBEG and coalesce(MD.DATEEND, '30.12.9999')) and
(cast(:OUT_STAC as date) between MR.DATEBEG and coalesce(MR.DATEEND, '30.12.9999')) and
((:STAC_DIAG like MD.CODE_DIAG || '%') or (:ACC1 like MD.CODE_DIAG || '%') or (:ACC2 like MD.CODE_DIAG || '%') or (:ACC3 like MD.CODE_DIAG || '%'))
into :P_MARK_CHECK, :P_M_RES_CHECK
do
begin
if (:P_ID_MARK = :P_MARK_CHECK) then
OUT_ERR_MARKER = 0;
if (:P_ID_M_R = :P_M_RES_CHECK) then
OUT_ERR_M_RES = 0;
end
if (:P_ID_MARK is null) then
OUT_ERR_MARKER = 1;
if (:P_ID_M_R is null) then
begin
if (coalesce(:P_REC_RSLT, 0) = 1) then
OUT_ERR_M_RES = 1;
else
OUT_ERR_M_RES = 0;
end
end
end
for select ODC.ID_DEC, ODC.DATE_DEC
from ONCO_DECLINE ODC
where ODC.ID_ONCO = :P_ID_ONCO
into :P_ID_DEC, :P_DATE_DEC
do
begin
if (:P_ID_DEC is null) then
OUT_ERR_DECLINE = 1;
if (:P_DATE_DEC is null) then
OUT_ERR_DATE_DECLINE = 1;
end
--------------------------------------------
if ((select iif(T.ID_IN_RANGE <> 0, 1, null) IS_IN
from (select first 1 ST.CODE_DIAG, sum(iif(:P_ID_STAGE = ST.ID_STAGE, 1, 0)) ID_IN_RANGE
from SPR_ONCO_STAGES ST
where ((:OUT_STAC) between ST.DATEBEG and coalesce(ST.DATEEND, '31.12.9999')) and
(((:STAC_DIAG like ST.CODE_DIAG || '%') ) --or (:ACC1 like ST.CODE_DIAG || '%') or (:ACC2 like ST.CODE_DIAG || '%') or (:ACC3 like ST.CODE_DIAG || '%')
or (ST.CODE_DIAG is null))
group by ST.CODE_DIAG
order by ST.CODE_DIAG desc) T) is null) then --     NULL
OUT_ERR_STAGE = 2;
if (:P_ID_STAGE is null) then
begin
if (((OPLAT = 1) and (coalesce(:P_ID_CAUSE, -1) in (0,1,2,3,4)))
or
((OPLAT = 6) and (coalesce(:P_ID_CAUSE, -1) in (0,1,2)))) then
OUT_ERR_STAGE = 1;
else
OUT_ERR_STAGE = 0;
end
--------------------------------------------
if ((select iif(T.ID_IN_RANGE <> 0, 1, null) IS_IN
from (select first 1 TM.CODE_DIAG, sum(iif(:P_ID_TUMOR = TM.id_TUMOR, 1, 0)) ID_IN_RANGE
from SPR_ONCO_TUMOR TM
where ((:OUT_STAC) between TM.DATEBEG and coalesce(TM.DATEEND, '31.12.9999')) and
(((:STAC_DIAG like TM.CODE_DIAG || '%') ) --or (:ACC1 like TM.CODE_DIAG || '%') or (:ACC2 like TM.CODE_DIAG || '%') or (:ACC3 like TM.CODE_DIAG || '%')
or (TM.CODE_DIAG is null))
group by TM.CODE_DIAG
order by TM.CODE_DIAG desc) T) is null) then --     NULL
OUT_ERR_TUMOR = 2;
if (:P_ID_TUMOR is null) then
begin
if ((coalesce(:P_ID_CAUSE, -1) = 0) and (:VOZRAST >= 18)) then
OUT_ERR_TUMOR = 1;
else
OUT_ERR_TUMOR = 0;
end
--------------------------------------------
if ((select iif(T.ID_IN_RANGE <> 0, 1, null) IS_IN
from (select first 1 ND.CODE_DIAG, sum(iif(:P_ID_NODUS = ND.ID_NODUS, 1, 0)) ID_IN_RANGE
from SPR_ONCO_NODUS ND
where ((:OUT_STAC) between ND.DATEBEG and coalesce(ND.DATEEND, '31.12.9999')) and
(((:STAC_DIAG like ND.CODE_DIAG || '%') ) --or (:ACC1 like ND.CODE_DIAG || '%') or (:ACC2 like ND.CODE_DIAG || '%') or (:ACC3 like ND.CODE_DIAG || '%')
or (ND.CODE_DIAG is null))
group by ND.CODE_DIAG
order by ND.CODE_DIAG desc) T) is null) then --     NULL
OUT_ERR_NODUS = 2;
if (:P_ID_NODUS is null) then
begin
if ((coalesce(:P_ID_CAUSE, -1) = 0) and (:VOZRAST >= 18)) then
OUT_ERR_NODUS = 1;
else
OUT_ERR_NODUS = 0;
end
--------------------------------------------
if ((select iif(T.ID_IN_RANGE <> 0, 1, null) IS_IN
from (select first 1 MT.CODE_DIAG, sum(iif(:P_ID_METAS = MT.ID_METAS, 1, 0)) ID_IN_RANGE
from SPR_ONCO_METAS MT
where ((:OUT_STAC) between MT.DATEBEG and coalesce(MT.DATEEND, '31.12.9999')) and
(((:STAC_DIAG like MT.CODE_DIAG || '%')) --or (:ACC1 like MT.CODE_DIAG || '%') or (:ACC2 like MT.CODE_DIAG || '%') or (:ACC3 like MT.CODE_DIAG || '%')
or (MT.CODE_DIAG is null))
group by MT.CODE_DIAG
order by MT.CODE_DIAG desc) T) is null) then --     NULL
OUT_ERR_METAS = 2;
if (:P_ID_METAS is null) then
begin
if ((coalesce(:P_ID_CAUSE, -1) = 0) and (:VOZRAST >= 18)) then
OUT_ERR_METAS = 1;
else
OUT_ERR_METAS = 0;
end
--------------------------------------------
if ((:P_DIST_METAS is not NULL) and (coalesce(P_ID_CAUSE, -1) not in (1,2))) then
OUT_ERR_DIST_METAS = 1;
--------------------------------------------
for select ou.id_onc_usl, ou.id_u_type, ou.id_surgery, ou.id_t_line, ou.id_t_cycle, ou.id_r_type
from onco_uslug ou
where ou.id_onco=:p_id_onco
into :P_ID_ONC_USL, :P_ID_U_TYPE, :P_ID_SURGERY, :P_ID_T_LINE, :P_ID_T_CYCLE, :P_ID_R_TYPE do
begin
OUT_ERR_ONCO_USLUG = 0;
if (:P_ID_U_TYPE is null) then
OUT_ERR_U_TYPE = 1;
if ((:P_ID_U_TYPE = 1) and (:P_ID_SURGERY is null)) then
OUT_ERR_U_TYPE = 1;
if (:P_ID_U_TYPE = 2) then
begin
if (:P_ID_T_LINE is null) then
OUT_ERR_ID_T_LINE = 1;
if (:P_ID_T_CYCLE is null) then
OUT_ERR_ID_T_CYCLE = 1;
end
if (:P_ID_U_TYPE is null) then
OUT_ERR_U_TYPE = 1;
if (:P_ID_U_TYPE in (3,4)) then
begin
if (:P_DOSE is null) then
OUT_ERR_DOSE = 1; --   ,      
if (:P_FRACTIONS is null) then
OUT_ERR_FRACTIONS = 1; --   ,      
if (:P_ID_R_TYPE is null) then
OUT_ERR_R_TYPE = 1;
end
for select om.code_drug, om.code_schem, om.date_inj
from onco_medicals om
where OM.ID_ONC_USL=:P_ID_ONC_USL
into :P_CODE_DRUG, :P_CODE_SCHEM, :P_DATE_ONJ do
begin
OUT_ERR_ONCO_MEDICALS = 0;
if (coalesce(:P_CODE_DRUG, '') = '') then
OUT_ERR_CODE_DRUG = 1;
if (coalesce(:P_CODE_SCHEM, '') = '') then
OUT_ERR_CODE_SCHEM = 1;
if ((upper(coalesce(:P_CODE_SCHEM, '')) <> upper('')) and
((left(:STAC_DIAG, 3) between 'C81' and 'C96') or (:vozrast < 18))) then
OUT_ERR_CODE_SCHEM = 2;
if ((upper(coalesce(:P_CODE_SCHEM, '')) = upper('')) and
(left(:STAC_DIAG, 3) not between 'C81' and 'C96') and
(:vozrast >= 18)) then
OUT_ERR_CODE_SCHEM = 3;
if (:P_DATE_ONJ is null) then
OUT_ERR_DATE_INJ = 1;
end
if ((:P_ID_U_TYPE not in (2,4)) and (OUT_ERR_ONCO_MEDICALS = 1)) then --  .     
OUT_ERR_ONCO_MEDICALS = 0;  --        
if (:P_ID_U_TYPE in (2,4)) then --.     
begin
if ((:P_WEIGHT is null) or (:P_HEIGHT is null) or (:P_BSA is null)) then
OUT_ERR_BODY_PARAMS = 1; --       
end
end
--------------------------------------------
if ((OUT_ERR_ONCO_USLUG = 1) and (p_id_cause not in (0,1,2))) then
OUT_ERR_ONCO_USLUG = 0; --     ,      
--------------------------------------------
if (OUT_ERR_ONCO_USLUG <> 0) then --           
    OUT_ERR_ONCO_MEDICALS = 0;
--------------------------------------------
for select con.pr_cons, con.dt_cons from consilium con
where CON.ID_ILL = :P_ID_ILL and CON.NOM_MTL = :P_NOM_MTL
into :P_PR_CONS, :P_DT_CONS
do
begin
OUT_ERR_CONSILIUM = 0;
if (:P_PR_CONS is null) then
OUT_ERR_PR_CONS = 1;
if ((:P_DT_CONS is null) and (:P_PR_CONS in (1, 2, 3))) then
OUT_ERR_DT_CONS = 1;
end
end
end
----------------------------------------
for
select od.dir_type, od.method, od.uslug_to, od.date_dir from onco_direction od
where od.id_ill=:id_ill and od.nom_mtl=:nom_mtl
into :P_DIR_TYPE, :P_METHOD, :P_USLUG_TO, :P_DATE_DIR
do
begin
if (:P_DATE_DIR is null) then
OUT_ERR_DIRECT_DATE = 1;
if (:P_DIR_TYPE is null) then
OUT_ERR_DIRECT_TYPE = 1;
if ((:P_DIR_TYPE = 3) and (:P_METHOD is null)) then
OUT_ERR_METHOD = 1;
if ((:P_USLUG_TO is null) and (:P_METHOD is not null)) then
OUT_ERR_USLUG_TO = 1;
end
suspend;
end;
@
commit work;
@