/*SpUpd!_2019.04.03_0000719*/
/*needVer=2019.04.03_0000718*/


CREATE OR ALTER procedure GET_ECO_INFO (
    ID_ILL integer,
    UR_COST smallint)
returns (
    ECO_STAGES_OUT varchar(10),
    ECO_KSG varchar(20),
    ECO_KSG_COST numeric(15,2))
as
declare variable STAGES varchar(10);
begin
  ECO_STAGES_OUT = '';
  for select cast(SK.STAGE as varchar(10)) STAGES, SK.KSG ECO_KSG,
             (
             case iif(0 = :UR_COST, M.UR_COST, :UR_COST)
               when 1 then KC.R_UR
               when 3 then KC.G_UR
               when 4 then iif(R.LPU in (26, 27), KC.N_UR, KC.K_UR)
               when 5 then KC.F_UR
             end) ECO_KSG_COST
      from STACION S
      join REPORTS R on R.REPN = S.REPN
      join MTL M on M.ID_ILL = S.ID_ILL and
            M.OPLAT = R.OPLAT
      join OPERAT O on O.ID_ILL = S.ID_ILL and
            O.NOM_MTL = M.NOM_MTL
      join STAGE_KSG SK on SK.USLUG = O.USLUG and
            SK.DATEBEG <= S.OUT_STAC and
            (SK.DATEEND >= S.OUT_STAC or SK.DATEEND is null)
      join SPR_KSG_COST KC on KC.KSG = SK.KSG and
            (S.OUT_STAC between KC.DBEG and coalesce(KC.DEND, "31.12.9999"))
      where (S.ID_ILL = :ID_ILL)
      order by STAGES
      into :STAGES, :ECO_KSG, :ECO_KSG_COST
  do
    ECO_STAGES_OUT = ECO_STAGES_OUT || :STAGES;
  suspend;
end;
@

CREATE OR ALTER procedure CONTROL_ECO (
    ID_ILL integer,
    LPU smallint,
    DR date,
    FAMILY varchar(40),
    NAME varchar(40),
    FATHER varchar(40),
    NOMIB varchar(50),
    OUT_STAC date,
    START_DREP date,
    REPN integer)
returns (
    ECO_ERR varchar(5))
as
declare variable LAST_STAGE smallint;
declare variable STAGE smallint;
declare variable MAX_STAGE smallint;
declare variable PR_STAGE smallint;
declare variable KSG smallint;
declare variable IS_ECO char(1);
declare variable TMP_NOM_MTL integer;
declare variable SUM_STAGES smallint;
declare variable CNT_STAGES integer;
declare variable ECO_INFO varchar(10);
declare variable ECO_KSG_ID varchar(20);
declare variable ECO_KSG_COST numeric(15,2);
begin
  LAST_STAGE = 0;
  ------------------------------
  execute procedure GET_ECO_INFO(:ID_ILL, 0)
      returning_values (ECO_INFO, ECO_KSG_ID, ECO_KSG_COST);
  if (ECO_INFO <> '') then
  begin
    select first 1 MK.STAGE
    from MAKED_ECO MK
    left join STACION S on S.ID_ILL = MK.ID_ILL
    left join REPORTS R on R.REPN = S.REPN
    where MK.LPU_ID = :LPU and
          MK.DR = :DR and
          ((MK.NOMIB = :NOMIB) or ((MK.FAMILY = :FAMILY) and
          (MK.NAME = :NAME) and
          (MK.FATHER = :FATHER))) and
          (MK.OUT_STAC < :OUT_STAC) and
          ((((R.SEE1 = 1 and
          R.SEE2 = 1) or (S.REPN = :REPN)) and
          S.SUM_MEK is null) or (extract(year from MK.OUT_STAC) < extract(year from :START_DREP)))
    order by MK.STAGE desc
    into :LAST_STAGE;
    if (ECO_INFO in ('1', '12', '123', '1234', '1235', '12345', '6')) then
      ECO_ERR = '0';
    else
      ECO_ERR = '1';
    if (ECO_ERR = '0') then
      for select distinct SK.STAGE
          from OPERAT O
          join STACION S on S.ID_ILL = O.ID_ILL
          join REPORTS R on R.REPN = O.REPN
          join STAGE_KSG SK on SK.USLUG = O.USLUG and
                SK.DATEBEG <= S.OUT_STAC and
                (SK.DATEEND >= S.OUT_STAC or SK.DATEEND is null)
          where O.ID_ILL = :ID_ILL
          order by SK.STAGE
          into :STAGE
      do
        insert into MAKED_ECO (LPU_ID, DR, NOMIB, STAGE, OUT_STAC, FINISHED, ID_ILL, FAMILY, NAME, FATHER)
        values (:LPU, :DR, :NOMIB, :STAGE, :OUT_STAC, 0, :ID_ILL, :FAMILY, :NAME, :FATHER);
  end
  suspend;
end;
@